<?xml version='1.0' encoding='UTF-8' ?>
<!DOCTYPE composition PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<ui:composition xmlns:ui="http://xmlns.jcp.org/jsf/facelets"
                xmlns="http://www.w3.org/1999/xhtml"
                xmlns:pt="http://xmlns.jcp.org/jsf/passthrough"
                xmlns:jsf="http://xmlns.jcp.org/jsf"
                xmlns:h="http://xmlns.jcp.org/jsf/html"
                xmlns:f="http://xmlns.jcp.org/jsf/core"
                template="./../plantilla-principal.xhtml"
                xmlns:o="http://omnifaces.org/ui">

    <ui:define name="contenido">
        <div class="ui center aligned container" style="padding-top: 40px">
            <h:form id="form-sorteo" prependId="false" class="ui huge form" onsubmit="#{sorteopremioManBean.listapremioxsorteo()}">
                <div class="fields">
                    <div class="six wide field">
                        <h:graphicImage library="imagenes" name="logo-completo-transparente.png" width="280" />   
                    </div>
                    <div class="ten wide field">
                        <div class="field">
                            <label>Sorteo</label>
                            <div id="sorteoselect" class="ui selection dropdown">
                                <input name="sorteoinput" id="sorteoinput" jsf:value="#{sorteopremioManBean.idSorteoSeleccionado}" type="hidden"/>
                                <i class="dropdown icon" />
                                <div class="default text">Sorteo</div>
                                <div class="menu">
                                    <ui:repeat value="#{sorteopremioManBean.listadeSorteo()}" var="sorteoprem">
                                        <div class="item" data-value="#{sorteoprem.idsorteo}">#{sorteoprem.descripcion}</div>
                                    </ui:repeat>
                                </div>
                            </div>
                        </div>
                        <div class="field" style="padding-top: 10px">
                            <label>Premio</label>
                            <div jsf:id="cmbPremios" class="ui selection dropdown">
                                <input name="inIdPremio" type="hidden" jsf:value="#{sorteopremioManBean.idPremioSeleccionado}" />
                                <i class="dropdown icon"></i>
                                <div class="default text">Premio</div>
                                <div class="menu">
                                    <ui:repeat value="#{sorteopremioManBean.lstPremios}" var="premio">
                                        <div class="item" data-value="#{premio.idpremios}">Premio N° #{premio.numeroPremio}: #{premio.descripcion}</div>
                                    </ui:repeat>
                                </div>
                            </div>
                        </div>
                    </div>

                </div>
                <div class="center aligned field">
                    <div id="second" class="ui fluid green massive basic label" style="font-size:50px;">000000</div>
                </div>
                <div  class="fields">
                    <div class="ten wide field">
                        <button id="btn-comenzar" class="ui fluid big green disabled button">Iniciar</button>
                    </div>
                    <div class="three wide field">
                        <button id="btn-cancelar" class="ui fluid big button">Cancelar</button>
                    </div>
                    <div class="three wide field">
                        <h:commandLink id="btn-verganadores" class="ui fluid big disabled button" actionListener="#{sorteopremioManBean.seleccionarSorteo()}">
                            Ganadores...
                            <f:ajax execute=":sorteoselect :inIdPremio @this" render=":tablaGanadores" onevent="function(data){ajaxMostrarGanadores(data)}" />
                        </h:commandLink>
                    </div>
                </div>
                <div jsf:id="fieldMsgGanador" class="field">
                    <span id="mensajeGanador" style="display:none;">
                        <h1 class="ui header">#{sorteopremioManBean.msgGanador}</h1>
                        <h4 class="ui header">#{sorteopremioManBean.msgNroCi}</h4>
                    </span>
                </div>
                <div id="msgYaSorteado" style="display:none;" class="field">
                    <div class="ui basic blue label"><i class="info icon" />El premio ya fue sorteado. Se reemplazará al anterior ganador.</div>
                </div>
                <h:inputHidden id="inIdGanador" value="#{sorteopremioManBean.idGanador}" />
                <h:inputHidden id="inJsonParticipantes" value="#{sorteopremioManBean.conversorStringJson()}" />
                <h:commandLink id="cmlSeleccionSorteo" style="display: none;" actionListener="#{sorteopremioManBean.seleccionarSorteo()}" >
                    <f:ajax render=":cmbPremios" onevent="function(data){ajaxSeleccionarSorteo(data)}" execute="@this sorteoinput" />
                </h:commandLink>
                <h:commandLink id="cmlRegistrarGanador" actionListener="#{sorteopremioManBean.registrarGanador()}">
                    <f:ajax onevent="function(data){ajaxRegistrarGanador(data)}" execute=":sorteoselect :inIdPremio :inIdGanador @this" render=":fieldMsgGanador :inJsonParticipantes" />
                </h:commandLink>
                <h:commandLink style="display:none;" id="cmlSeleccionPremio" actionListener="#{sorteopremioManBean.seleccionarPremio()}">
                    <f:ajax execute=":inIdPremio @this" render=":inIdGanador" onevent="function(data){ajaxSeleccionarPremio(data)}" />
                </h:commandLink>
            </h:form>

            <div id="dlgGanadores" class="ui modal">
                <div id="tituloDlgGanadores" class="header">
                    Profile Picture
                </div>
                <div class="content">
                    <table jsf:id="tablaGanadores" class="ui basic table">
                        <thead>
                            <tr>
                                <th>NRO.</th>
                                <th>PREMIO</th>
                                <th>COD. SUSC.</th>
                                <th>NOMBRES Y APELLIDOS</th>
                                <th>DOCUMENTO</th>
                            </tr>
                        </thead>
                        <tbody>
                            <ui:repeat value="#{sorteopremioManBean.lstPremios}" var="pr">
                                <tr>
                                    <td>#{pr.numeroPremio}</td> 
                                    <td>#{pr.descripcion}</td> 
                                    <td>#{empty pr.ganador?'(Pendiente de sorteo)':pr.ganador.idsuscripcion}</td> 
                                    <td>#{empty pr.ganador?'(Pendiente de sorteo)':pr.ganador.cliente.razonSocial}</td>
                                    <td>#{empty pr.ganador?'(Pendiente de sorteo)':sorteopremioManBean.enmascararCi(pr.ganador.cliente.ci)}</td>
                                </tr>
                            </ui:repeat>
                        </tbody>
                    </table>
                </div>
                <div class="actions">
                    <div class="ui right labeled red deny icon button">
                        <i class="close icon" />
                        Cerrar
                    </div>
                </div>
            </div>
        </div>
        <script type="text/javascript">
            //Variables globales
            var tiempo_corriendo = null;
            var tiempo = {
                segundo: 0
            };

            //Funciones AJAX
            function ajaxSeleccionarPremio(data) {
                var status = data.status;
                switch (status) {
                    case 'success':
                    {
                        if ($('#inIdGanador').val() === '' || $('#inIdGanador').val() === '0') {
                            $('#msgYaSorteado').hide();
                        } else {
                            $('#msgYaSorteado').show();
                        }
                    }
                }
            }

            function ajaxMostrarGanadores(data) {
                var status = data.status;
                switch (status) {
                    case 'success':
                    {
                        $('#tituloDlgGanadores').empty();
                        $('#tituloDlgGanadores').append($('#sorteoselect').dropdown('get text'));
                        $('#dlgGanadores').modal('show');
                    }                 }
            }

            function ajaxSeleccionarSorteo(data) {
                var status = data.status;
                switch (status) {
                    case 'success':
                    {
                        activarComboPremios();
                    }
                }
            }

            function ajaxRegistrarGanador(data) {
                var status = data.status;
                switch (status) {
                    case 'success':
                    {
                        console.log('hay nuevo ganador');
                        $('#mensajeGanador').show();
                    }
                }
            }

            //Metodos auxiliares

            function activarBotonIniciar() {
                var idPremio = $("#inIdPremio").val();
                if (idPremio === '') {
                    $('#btn-comenzar').addClass('disabled');
                } else {
                    $('#btn-comenzar').removeClass('disabled');
                }
            }

            function activarComboSorteos() {
                $("#sorteoselect").dropdown({onChange: function () {
                        console.log('se selecciona sorteo');
                        $("#cmbPremios").dropdown('clear');
                        if ($('#sorteoinput').val() !== '') {
                            $('#btn-verganadores').removeClass('disabled')
                        } else {
                            $('#btn-verganadores').addClass('disabled')
                        }

                        $("#cmlSeleccionSorteo").click();
                    }
                });
            }
            function activarComboPremios() {
                $("#cmbPremios").dropdown({
                    onChange: function () {
                        console.log('cmb premios');
                        $('#cmlSeleccionPremio').click();
                        $('#mensajeGanador').hide();
                        $('#second').empty();
                        $('#second').append('000000');
                        activarBotonIniciar();
                    }
                });
            }

            function sortear() {
                var lista = JSON.parse($('#inJsonParticipantes').val());
                var i = lista.length;
                while (i--) {
                    var j = Math.floor(Math.random() * (i + 1));
                    var tmp = lista[i];
                    lista[i] = lista[j];
                    lista[j] = tmp;
                }
                $('#mensajeGanador').hide();
                $('#sorteoselect').addClass('disabled');
                $('#cmbPremios').addClass('disabled');
                $('#btn-verganadores').addClass('disabled');
                $('#btn-comenzar').text('Detener');
                tiempo_corriendo = setInterval(function () {
                    // Segundos
                    tiempo.segundo++;
                    if (tiempo.segundo >= lista.length)
                    {
                        tiempo.segundo = 0;
                    }
                    $("#second").text(lista[tiempo.segundo]);
                }, 1);
            }

            function detenerSorteo() {
                $('#sorteoselect').removeClass('disabled');
                $('#cmbPremios').removeClass('disabled');
                $('#btn-verganadores').removeClass('disabled');
                $('#inIdGanador').val(parseInt($("#second").html()));
                $('#btn-comenzar').text('Iniciar');
                clearInterval(tiempo_corriendo);
                $('#cmlRegistrarGanador').click();
                $('#msgYaSorteado').hide();
            }

            $(document).ready(function () {
                $('#inIdGanador').val('');
                activarComboSorteos();

                $("#sorteoselect").dropdown('clear');
                $("#cmbPremios").dropdown('clear');



                $("#btn-comenzar").click(function () {
                    if ($('#btn-comenzar').text() === 'Iniciar') {
                        sortear();
                    } else {
                        detenerSorteo();
                    }

                    return false;
                });

                $('#btn-cancelar').click(function () {
                    clearInterval(tiempo_corriendo);
                    $('#second').empty();
                    $('#second').append('000000');
                    $('#btn-comenzar').text('Iniciar');
                    $('#sorteoselect').removeClass('disabled');
                    $('#cmbPremios').removeClass('disabled');
                    $('#btn-verganadores').removeClass('disabled');
                    return false;
                });
            });
        </script>
    </ui:define>

</ui:composition>